/* Slide.

   Copyright (C) 2000 Daiki Ueno <ueno@unixuser.org>

   Author: Daiki Ueno <ueno@unixuser.org>
   Created: 2000-05-16

   This file is part of UltraPoint.

   This program is free software; you can redistribute it and/or modify 
   it under the terms of the GNU General Public License as published by 
   the Free Software Foundation; either version 2, or (at your option)  
   any later version.                                                   

   This program is distributed in the hope that it will be useful,      
   but WITHOUT ANY WARRANTY; without even the implied warranty of       
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the        
   GNU General Public License for more details.                         

   You should have received a copy of the GNU General Public License    
   along with GNU Emacs; see the file COPYING.  If not, write to the    
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,         
   Boston, MA 02111-1307, USA.                                          

*/

#ifndef __UPT_SLIDE_H_
#define __UPT_SLIDE_H_

#include "canvas.h"
#include "xml.h"

extern gdouble slide_min_glue_width;
extern gdouble slide_max_glue_width;
extern gdouble slide_agglutinative_min_glue_width;
extern gdouble slide_agglutinative_max_glue_width;
extern gdouble slide_base_lineskip;
extern ggi_pixel slide_itemize_foreground_pixel;
extern ggi_pixel slide_header_foreground_pixel;
extern ggi_pixel slide_border_foreground_pixel;
extern gint slide_border_thickness;

void upt_slideshow_draw (UptCanvas *canvas, UptXMLSlideShow *slideshow);
void upt_slideshow_next (UptXMLSlideShow *slideshow);
void upt_slideshow_previous (UptXMLSlideShow *slideshow);

#endif
